  $ cat >> $HGRCPATH <<EOF
  > [defaults]
  > amend=-d "0 0"
  > [extensions]
  > hgext.rebase=
  > hgext.graphlog=
  > EOF
  $ echo "obsolete=$(echo $(dirname $TESTDIR))/hgext/obsolete.py" >> $HGRCPATH

  $ glog() {
  >   hg glog --template '{rev}:{node|short}@{branch}({phase}) {desc|firstline}\n'\
  >     "$@"
  > }

  $ hg init repo
  $ cd repo
  $ echo a > a
  $ hg ci -Am adda
  adding a
  $ echo a >> a
  $ hg ci -m changea

Test regular rebase

  $ hg up 0
  1 files updated, 0 files merged, 0 files removed, 0 files unresolved
  $ echo b > b
  $ hg ci -Am addb
  adding b
  created new head
  $ hg rebase -d 1 --keep  
  abort: rebase --keep option is unsupported with obsolete extension
  (see 'hg help obsolete')
  [255]
  $ hg rebase -d 1
  $ glog --hidden
  @  3:03f017c74faa@default(draft) addb
  |
  | o  2:102a90ea7b4a@default(secret) addb
  | |
  o |  1:540395c44225@default(draft) changea
  |/
  o  0:07f494440405@default(draft) adda
  
  $ hg debugsuccessors
  102a90ea7b4a 03f017c74faa

Test rebase with deleted empty revision

  $ hg up 0
  1 files updated, 0 files merged, 1 files removed, 0 files unresolved
  $ hg branch foo
  marked working directory as branch foo
  (branches are permanent and global, did you want a bookmark?)
  $ echo a >> a
  $ hg ci -m changea
  $ hg rebase -d 1
  $ glog --hidden
  o  4:4e322f7ce8e3@foo(secret) changea
  |
  | o  3:03f017c74faa@default(draft) addb
  | |
  +---o  2:102a90ea7b4a@default(secret) addb
  | |
  | @  1:540395c44225@default(draft) changea
  |/
  o  0:07f494440405@default(draft) adda
  
  $ hg debugsuccessors
  102a90ea7b4a 03f017c74faa
  4e322f7ce8e3 000000000000

Test rebase --collapse

  $ hg up 0
  1 files updated, 0 files merged, 0 files removed, 0 files unresolved
  $ echo c > c
  $ hg ci -Am addc
  adding c
  created new head
  $ echo c >> c
  $ hg ci -m changec
  $ hg rebase --collapse -d 1
  merging c
  $ glog --hidden
  @  7:a7773ffa7edc@default(draft) Collapsed revision
  |
  | o  6:03f31481307a@default(secret) changec
  | |
  | o  5:076e9b2ffbe1@default(secret) addc
  | |
  | | o  4:4e322f7ce8e3@foo(secret) changea
  | |/
  +---o  3:03f017c74faa@default(draft) addb
  | |
  | | o  2:102a90ea7b4a@default(secret) addb
  | |/
  o |  1:540395c44225@default(draft) changea
  |/
  o  0:07f494440405@default(draft) adda
  
  $ hg debugsuccessors
  03f31481307a a7773ffa7edc
  076e9b2ffbe1 a7773ffa7edc
  102a90ea7b4a 03f017c74faa
  4e322f7ce8e3 000000000000

Test rebase --abort

  $ hg debugsuccessors > ../successors.old
  $ hg up 0
  1 files updated, 0 files merged, 1 files removed, 0 files unresolved
  $ echo d > d
  $ hg ci -Am addd d
  created new head
  $ echo b >> a
  $ hg ci -m appendab
  $ hg rebase -d 1
  merging a
  warning: conflicts during merge.
  merging a incomplete! (edit conflicts, then use 'hg resolve --mark')
  abort: unresolved conflicts (see hg resolve, then hg rebase --continue)
  [255]
  $ hg rebase --abort
  saved backup bundle to $TESTTMP/repo/.hg/strip-backup/03f165c84ea8-backup.hg
  rebase aborted
  $ hg debugsuccessors > ../successors.new
  $ diff -u ../successors.old ../successors.new

Test rebase --continue

  $ hg rebase -d 1
  merging a
  warning: conflicts during merge.
  merging a incomplete! (edit conflicts, then use 'hg resolve --mark')
  abort: unresolved conflicts (see hg resolve, then hg rebase --continue)
  [255]
  $ hg resolve --tool internal:other a
  $ hg rebase --continue
  $ glog --hidden
  @  11:1951ead97108@default(draft) appendab
  |
  o  10:03f165c84ea8@default(draft) addd
  |
  | o  9:4b9d80f48523@default(secret) appendab
  | |
  | o  8:a31943eabc43@default(secret) addd
  | |
  +---o  7:a7773ffa7edc@default(draft) Collapsed revision
  | |
  | | o  6:03f31481307a@default(secret) changec
  | | |
  | | o  5:076e9b2ffbe1@default(secret) addc
  | |/
  | | o  4:4e322f7ce8e3@foo(secret) changea
  | |/
  +---o  3:03f017c74faa@default(draft) addb
  | |
  | | o  2:102a90ea7b4a@default(secret) addb
  | |/
  o |  1:540395c44225@default(draft) changea
  |/
  o  0:07f494440405@default(draft) adda
  
  $ hg debugsuccessors > ../successors.new
  $ diff -u ../successors.old ../successors.new
  --- ../successors.old* (glob)
  +++ ../successors.new* (glob)
  @@ -1,4 +1,6 @@
   03f31481307a a7773ffa7edc
   076e9b2ffbe1 a7773ffa7edc
   102a90ea7b4a 03f017c74faa
  +4b9d80f48523 1951ead97108
   4e322f7ce8e3 000000000000
  +a31943eabc43 03f165c84ea8
  [1]
